<template>
  <div class="container">
    <h2>New RelEffectSpecial</h2>
    <b-form-input
      v-model="effect_id"
      required
      placeholder="effect id"
      type="number">
    </b-form-input>
    <small>In case you don't know the effect id, visit <nuxt-link to="/admin/effects">effects</nuxt-link></small>
    <b-form-input
      v-model="special_id"
      required
      placeholder="special id"
      type="number">
    </b-form-input>
    <small>In case you don't know the special id, visit <nuxt-link to="/admin/specials">specials</nuxt-link></small>
    <b-form-input
      v-model="chance"
      required
      placeholder="chance"
      type="number">
    </b-form-input>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
    <div>
      <b-alert
        :show="error != ''"
        variant="danger">
        {{ error }}
      </b-alert>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      effect_id: '',
      special_id: '',
      chance: '',
      error: ''
    };
  },
  computed: {
    valid() {
      return this.chance <= 1 && this.effect_id * this.special_id * this.chance > 0;
    }
  },
  methods: {
    submit() {
      let data = {
        rel_effect_specials: {
          chance: this.chance,
          effect_id: this.effect_id,
          special_id: this.special_id
        }
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/rel_effect_specials',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.effect_id = '';
      this.special_id = '';
      this.chance = '';
      this.error = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}
</style>
